10 REM         Graph E-meter V vs. I, by Lee Hart 11/3/2000
20 REM         Volts=vertical axis, Amps=horizontal axis, Ah=color
25 REM
30 REM         variables:
31 a = 0: REM  amps sample
33 c$ = "": REM comment from line 1 in data file
34 d = 0: REM  date from line 1 in data file
35 e = 0: REM  last error code
38 h = 0: REM  amphours sample
49 t# = 0: REM time of sample
52 v = 0: REM  voltage sample
54 xl = 200: xr = 639: REM x-axis (horizontal) left and right limits
55 yt = 10: yb = 180: REM y-axis (vertical) top and bottom limits
57 REM
60 SCREEN 8: REM EGA 640x200x16 colors
70 CLS : FILES "*.DAT"
80 ON ERROR GOTO 1000
90 LOCATE 25, 1: INPUT "Data file to graph (or ENTER to exit)? ", file$
95 e = 0: OPEN file$ FOR INPUT AS #1
100 IF e = 52 THEN END
105 IF e = 53 GOTO 90
110 INPUT #1, t$, v$, ah$, a$, d$, c$
120 CLS : PRINT d$; " "; file$; " "; c$
130 REM
140 REM        scan data file for max/min values
150 REM
160 IF EOF(1) GOTO 700
170 INPUT #1, t$, v, h, a: REM input initial values
180 GOSUB 930: tl# = t#: LOCATE 6, 1: PRINT "Start = "; t$
190 vl = v: vh = v: hl = h: hh = h: al = a: ah = a
200 IF EOF(1) GOTO 700
210 INPUT #1, t$, v, h, a
220 GOSUB 930: th# = t#
230 IF v > vh THEN vh = v ELSE IF v < vl THEN vl = v
240 IF h > hh THEN hh = h ELSE IF h < hl THEN hl = h
250 IF a > ah THEN ah = a ELSE IF a < al THEN al = a
260 LOCATE 7, 1: COLOR 7: PRINT "  End = "; t$
280 PRINT : COLOR 4: PRINT "Vmax ="; vh: PRINT "Vmin ="; vl
290 PRINT : COLOR 1: PRINT "Amax ="; ah: PRINT "Amin ="; al
310 PRINT : COLOR 2: PRINT "AHmax="; hh: PRINT "AHmin="; hl
320 IF EOF(1) = 0 GOTO 210
330 REM
340 REM        round off high/low limits
350 REM
360 vl = INT(vl * 2) / 2: vh = INT(vh * 2) / 2 + .5: REM to nearest 0.5v
370 al = INT(al / 5) * 5: ah = INT(ah / 5) * 5 + 5: REM to nearest 5a
380 hl = INT(hl): hh = INT(hh) + 1: REM to nearest amphr
390 REM
400 REM        close, reopen file
410 REM
420 t# = tl#: d = 0
430 CLOSE #1: OPEN file$ FOR INPUT AS #1
440 t# = th# - tl#: t$ = STR$(t# \ 3600)
450 t# = t# - (t# \ 3600) * 3600: t$ = t$ + ":" + RIGHT$(STR$(t# \ 60 + 100), 2)
460 t# = t# - (t# \ 60) * 60: t$ = t$ + ":" + RIGHT$(STR$(t# + 100), 2)
470 REM
480 REM        get 1st line headings and comments, label graph axes
490 REM
500 INPUT #1, t$, v$, ah$, a$, d$, c$
510 IF EOF(1) GOTO 700
520 COLOR 7: LINE (xr, yb)-(xl, yt), , B: REM draw box where graph goes
530 LOCATE 20, 1: PRINT : PRINT TAB(16); "^": PRINT TAB(16); "|": PRINT TAB(14); v$
540 FOR i = vl TO vh STEP .5: LOCATE (23 + (2 - 23) * (i - vl) / (vh - vl)), 20: PRINT i: NEXT i
550 FOR i = al TO ah STEP 5: LOCATE 24, (26 + (77 - 26) * (i - al) / (ah - al)): PRINT i; : NEXT i
560 LOCATE 24, 14: PRINT a$; "-->";
570 REM LOCATE 24, (27 + (78 - 27) * -al / (ah - al)): PRINT "0";
600 REM
610 REM        get data points, and plot them
620 REM
630 INPUT #1, t$, v, h, a: REM get next line of data
640 GOSUB 930
650 COLOR 1 + INT(6 * (h - hl) / (hh - hl))
660 PSET (xl + (xr - xl) * (a - al) / (ah - al), yb + (yt - yb) * (v - vl) / (vh - vl))
670 IF EOF(1) = 0 GOTO 630
680 REM
690 REM        end of file; close file, ask to graph another or exit
700 COLOR 7
710 CLOSE #1
720 LOCATE 25, 1: PRINT "Type SPACE for another file, any other key to exit."; : t$ = INPUT$(1)
730 IF t$ = " " THEN GOTO 10 ELSE END
900 REM
910 REM        subroutine to convert time$ to number of seconds
920 REM
930 t0# = t#
940 IF LEN(t$) = 5 THEN t# = 3600 * VAL(t$) + 60 * VAL(RIGHT$(t$, 2))
950 IF LEN(t$) = 8 THEN t# = 3600 * VAL(t$) + 60 * VAL(MID$(t$, 4, 2)) + VAL(RIGHT$(t$, 2))
960 t# = t# + day * 86400: IF t# < t0# THEN d = d + 1: t# = t# + 86400
970 RETURN
980 REM        error handler
990 REM
1000 e = ERR
1010 PRINT "Error"; ERR; ": ";
1020 IF e = 52 THEN PRINT "No file name. ";
1030 IF e = 53 THEN PRINT "File not found. ";
1040 RESUME NEXT

