10 REM          Program to graph E-meter data, by Lee Hart 10/27/2000
20 REM          (need to modify to allow extra comments at end of lines)
30 REM         variables:
31 a = 0: REM   amps sample
33 c$ = "": REM comment from line 1 in data file
34 d = 0: REM   date from line 1 in data file
35 e = 0: REM   last error code
38 h = 0: REM   amphours sample
49 t# = 0: REM  time of sample
52 v = 0: REM   voltage sample
54 xl = 200: xr = 639: REM   graph x (horizontal) left and right limits
55 yt = 10: yb = 180: REM graph y (vertical) top and bottom limits
57 REM
60 SCREEN 8: REM EGA 640x200x16 colors
70 CLS : FILES "*.DAT"
80 ON ERROR GOTO 1000
90 LOCATE 25, 1: INPUT "Data file to graph (or ENTER to exit)? ", file$
95 e = 0: OPEN file$ FOR INPUT AS #1
100 IF e = 52 THEN END
105 IF e = 53 GOTO 90
110 INPUT #1, t$, v$, ah$, a$, d$, c$
120 CLS : PRINT d$; " "; file$; " "; c$
130 REM
140 REM        scan data file for max/min values
150 REM
160 IF EOF(1) GOTO 500
170 INPUT #1, t$, v, h, a: REM input initial values
180 GOSUB 930: tl# = t#: LOCATE 6, 1: PRINT "Start = "; t$
190 vl = v: vh = v: hl = h: hh = h: al = a: ah = a
200 IF EOF(1) GOTO 500
210 INPUT #1, t$, v, h, a
220 GOSUB 930: th# = t#
230 IF v > vh THEN vh = v ELSE IF v < vl THEN vl = v
240 IF h > hh THEN hh = h ELSE IF h < hl THEN hl = h
250 IF a > ah THEN ah = a ELSE IF a < al THEN al = a
260 LOCATE 7, 1: COLOR 7: PRINT "  End = "; t$
280 PRINT : COLOR 4: PRINT "Vmax ="; vh: PRINT "Vmin ="; vl
290 PRINT : COLOR 1: PRINT "Amax ="; ah: PRINT "Amin ="; al
295 PRINT : COLOR 2: PRINT "AHmax="; hh: PRINT "AHmin="; hl
300 IF EOF(1) = 0 GOTO 210
310 REM
311 REM        round off high/low limits
312 REM
313 vl = INT(vl * 2) / 2: vh = INT(vh * 2) / 2 + .5
316 al = INT(al): ah = INT(ah) + 1
318 hl = INT(hl): hh = INT(hh) + 1
320 REM 
325 REM        close, reopen file, and plot data
330 REM
340 t# = tl#: d = 0
345 CLOSE #1: OPEN file$ FOR INPUT AS #1
346 t# = th# - tl#: t$ = STR$(t# \ 3600)
347 t# = t# - (t# \ 3600) * 3600: t$ = t$ + ":" + RIGHT$(STR$(t# \ 60 + 100), 2)
348 t# = t# - (t# \ 60) * 60: t$ = t$ + ":" + RIGHT$(STR$(t# + 100), 2)
349 LOCATE 24, 72: COLOR 7: PRINT t$;
350 INPUT #1, t$, v$, ah$, a$, d$, c$: REM get 1st line headings and comments
360 IF EOF(1) GOTO 500
370 LINE (xr, yb)-(xl, yt), , BF
372 COLOR 4: LOCATE 2, 1: PRINT vh: LOCATE 23, 1: PRINT vl: LOCATE 24, 2: PRINT v$;
374 COLOR 2: LOCATE 2, 10: PRINT hh: LOCATE 23, 10: PRINT hl: LOCATE 24, 10: PRINT ah$;
376 COLOR 1: LOCATE 2, 18: PRINT ah: LOCATE 23, 18: PRINT al: LOCATE 24, 18: PRINT a$;
378 COLOR 7: LOCATE 24, 51: PRINT t$;
379 REM
380 INPUT #1, t$, v, h, a: REM get next line of data
390 GOSUB 930
400 IF t# = tl# THEN LOCATE 24, 26: COLOR 7: PRINT "00:00:00"; : t0# = t#: v0 = v: h0 = h: a0 = a
410 COLOR 4: LINE (xl + (xr - xl) * (t0# - tl#) / (th# - tl#), yb + (yt - yb) * (v0 - vl) / (vh - vl))-(xl + (xr - xl) * (t# - tl#) / (th# - tl#), yb + (yt - yb) * (v - vl) / (vh - vl))
412 COLOR 2: LINE (xl + (xr - xl) * (t0# - tl#) / (th# - tl#), yb + (yt - yb) * (h0 - hl) / (hh - hl))-(xl + (xr - xl) * (t# - tl#) / (th# - tl#), yb + (yt - yb) * (h - hl) / (hh - hl))
414 COLOR 1: LINE (xl + (xr - xl) * (t0# - tl#) / (th# - tl#), yb + (yt - yb) * (a0 - al) / (ah - al))-(xl + (xr - xl) * (t# - tl#) / (th# - tl#), yb + (yt - yb) * (a - al) / (ah - al))
420 v0 = v: h0 = h: a0 = a
430 IF EOF(1) = 0 GOTO 380
500 COLOR 7
510 CLOSE #1
520 LOCATE 25, 1: PRINT "Type SPACE for another file, any other key to exit."; : t$ = INPUT$(1)
530 IF t$ = " " THEN GOTO 10 ELSE END
900 REM
910 REM        subroutine to convert time$ to number of seconds
920 REM
930 t0# = t#
940 IF LEN(t$) = 5 THEN t# = 3600 * VAL(t$) + 60 * VAL(RIGHT$(t$, 2))
950 IF LEN(t$) = 8 THEN t# = 3600 * VAL(t$) + 60 * VAL(MID$(t$, 4, 2)) + VAL(RIGHT$(t$, 2))
960 t# = t# + day * 86400: IF t# < t0# THEN d = d + 1: t# = t# + 86400
970 RETURN
980 REM        error handler
990 REM
1000 e = ERR
1010 PRINT "Error"; ERR; ": ";
1020 IF e = 52 THEN PRINT "No file name. ";
1030 IF e = 53 THEN PRINT "File not found. ";
1040 RESUME NEXT

